
#include <tigcclib.h>

#define MERDE "Oh shoot."
#define MSG "Not enough memory"
#define STV "Starvak"
INT_HANDLER interrupt1=0;
INT_HANDLER interrupt5=0;
unsigned char pe[]={0xE0,0xE0,0xE0},ps[]={0x80,0xC0,0xA0,0xC0,0x80};
int hs[]={100,90,80,70,60,50,40,30,20,10,0};

unsigned char* ex=NULL;
unsigned char* ey=NULL;

void stop(void)
{
	free(ex);
	free(ey);
	SetIntVec(AUTO_INT_1,interrupt1);
  SetIntVec(AUTO_INT_5,interrupt5);
	abort();
}
void drawEnemy(unsigned char x,unsigned char y)
{
	/*Draws an enemy at the point (x,y).
	Arrangement of pixels (X represents the point):
	1 1
	 X
	1 1
	*/
	Sprite8(x-1,y-1,3,pe,LCD_MEM,SPRT_XOR);
}
void drawShip(unsigned char x,unsigned char y)
{
	/*Draws a ship at the point (x,y).
	X is the point.
	1
	11
	1 X
	11
	1
	*/
	Sprite8(x-2,y-2,5,ps,LCD_MEM,SPRT_XOR);
}
void delay(void) {
    short int loop = 100, randNum=0;

    // generate random numbers to slow down the program...
    while (loop-- > 0) {
        randNum = rand() % loop;
    }
}
CALLBACK short cmp(const void* a,const void* b)
{
	return -fcmp(*(const short*)a,*(const short*)b);
}
void titlescn(void)
{
	ClrScr();
	if (!GrayOn()) return;
	GraySetAMSPlane(LIGHT_PLANE);
	
	ScrRectFill(&(SCR_RECT){{0,0,159,99}},&(SCR_RECT){{0,0,159,99}},A_NORMAL);
	static MULTI_LINE star={8,
													{
														{A_REVERSE,24,2,15,13},{A_REVERSE,24,2,23,16},{A_REVERSE,23,16,31,25},{A_REVERSE,31,25,18,23},{A_REVERSE,18,23,9,32},{A_REVERSE,9,32,12,20},{A_REVERSE,12,20,0,8},{A_REVERSE,0,8,15,13}
													}};
	DrawMultiLines(16,17,&star);
	DrawMultiLines(119,40,&star);
	GraySetAMSPlane(DARK_PLANE);
	FontSetSys(F_8x10);
	DrawStr(8,56,"Ardtha Productions",A_NORMAL);
	FontSetSys(F_6x8);
	DrawStr(47,67,"presents...",A_NORMAL);
	OSFreeTimer(USER_TIMER);
	OSRegisterTimer(USER_TIMER,60);
	while (!OSTimerExpired(USER_TIMER))
	{
		
	}
	GrayOff();
}
// Main Function
void _main(void)
{
	//initialize vars
	titlescn();
	int choice=0;
	randomize();
	char array1[]={62,62,59,44,62};
	char array2[]={92,92,95,110,92};
	int ne=0;
	ex=NULL;
	ey=NULL;
	while (choice!=4)
	{
		if ((ex=(unsigned char*) realloc(ex,2))==NULL)
			{
				DlgMessage(MERDE,MSG,BT_NONE,BT_CANCEL);
				return;
			}
		if ((ey=(unsigned char*) realloc(ey,2))==NULL)
			{
				DlgMessage(MERDE,MSG,BT_NONE,BT_CANCEL);
				free(ex);
				return;
			}
		unsigned char shipx=5,shipy=50;
		int health=100;
		int score=0;
		choice=0;
		//Draws the main menu.
		ClrScr();
		//0=play,1=help,2=about,3=quit
		FontSetSys(F_8x10);
		DrawStr(52,10,"tarvak",A_NORMAL);
		FontSetSys(F_6x8);
		DrawStr(62,24,">Play<",A_NORMAL);
		DrawStr(68,32,"Help",A_NORMAL);
		DrawStr(65,40,"About",A_NORMAL);
		DrawStr(50,48,"Highscores",A_NORMAL);
		DrawStr(68,56,"Quit",A_NORMAL);
		//wait for user to pick a choice
		int key=0;
		while ((key=ngetchx())!=KEY_ENTER)
		{
			DrawStr(array1[choice],24+8*choice," ",A_REPLACE);
			DrawStr(array2[choice],24+8*choice," ",A_REPLACE);
			if (key==KEY_UP && choice!=0) choice--;
			if (key==KEY_DOWN && choice!=4) choice++;
			DrawStr(array1[choice],24+8*choice,">",A_NORMAL);
			DrawStr(array2[choice],24+8*choice,"<",A_NORMAL);
		}
		if (choice==0)
		{
			ClrScr();
			interrupt1 = GetIntVec(AUTO_INT_1); // save auto-interrupt 1
    	interrupt5 = GetIntVec(AUTO_INT_5); // save auto-interrupt 5
			SetIntVec(AUTO_INT_1,DUMMY_HANDLER);
 	   	SetIntVec(AUTO_INT_5,DUMMY_HANDLER);
			//first enemy
			ex[0]=158;
			ey[0]=2+random(96);
			ne=1;
			//draw it
			drawEnemy(ex[0],ey[0]);
			//now draw the ship
			drawShip(5,50);
			/*
			The rules are:
			You can move up, down, left or right.
			2<=y<=98
			2<=x<=12
			Enemies that pass through the left boundary
			cost you 5 health each.
			Enemies that collide with you cost you 10 health each.
			Shoot with (key).
			Enemies that get hit by the beam earn you
			1 point each.
			*/
			int key=0;
			while (health>0)
			{
				//get the key (1=up,2=left,4=down,8=right,16=2nd)
				key=_rowread(~0x0001);
				//move ship
				drawShip(shipx,shipy);
				if ((key&2) && shipx!=2) shipx--;
				if ((key&8) && shipx!=12) shipx++;
				if ((key&1) && shipy!=2) shipy--;
				if ((key&4) && shipy!=98) shipy++;
				if (key&16)
				{
					//ZAP!
					SetIntVec(AUTO_INT_1,interrupt1);
  				SetIntVec(AUTO_INT_5,interrupt5);
					DrawLine(shipx,shipy,159,shipy,A_XOR);
					delay();
					DrawLine(shipx,shipy,159,shipy,A_XOR);

					SetIntVec(AUTO_INT_1,DUMMY_HANDLER);
 					SetIntVec(AUTO_INT_5,DUMMY_HANDLER);
				}
				else delay();
				drawShip(shipx,shipy);
				//move enemies
				unsigned short i=0;
				for(i=0;i<ne;i++)
				{
					drawEnemy(ex[i],ey[i]);
					ex[i]--;
					drawEnemy(ex[i],ey[i]);
					//enemies passing bounds
					if (ex[i]==1)
					{
						//erase
						drawEnemy(ex[i],ey[i]);
						//take health
						health-=5;
						//delete enemy
						unsigned short j=i;
						for(j=i;j<ne;j++)
						{
							ex[j]=ex[j+1];
							ey[j]=ey[j+1];
						}
						ex=(unsigned char*) realloc(ex,ne);
						if (ex==NULL)
						{
							stop();
						}
						ey=(unsigned char*) realloc(ey,ne);
						if (ey==NULL)
						{
							stop();
						}
						ne--;
						continue;
					}
					//collision
					if (abs(shipy-ey[i])<=3 && abs(shipx-ex[i])<=1)
					{
						//erase
						drawEnemy(ex[i],ey[i]);
						//take health
						health-=10;
						//delete enemy
						unsigned short j=i;
						for(j=i;j<ne;j++)
						{
							ex[j]=ex[j+1];
							ey[j]=ey[j+1];
						}
						ex=(unsigned char*) realloc(ex,ne);
						if (ex==NULL)
						{
							stop();
						}
						ey=(unsigned char*) realloc(ey,ne);
						if (ey==NULL)
						{
							stop();
						}
						ne--;
						continue;
					}
					//hit by beam
					if (abs(ey[i]-shipy)<=1 && (key&16))
					{
						//erase
						drawEnemy(ex[i],ey[i]);
						//give point
						score++;
						//delete enemy
						unsigned short j=i;
						for(j=i;j<ne;j++)
						{
							ex[j]=ex[j+1];
							ey[j]=ey[j+1];
						}
						ex=(unsigned char*) realloc(ex,ne);
						if (ex==NULL)
						{
							stop();
						}
						ey=(unsigned char*) realloc(ey,ne);
						if (ey==NULL)
						{
							stop();
						}
						ne--;
						continue;
					}
				}
			//now new enemies!
				if (!(rand()%(4+(rand()%16))))
				{
					unsigned char x=158;
					unsigned char y=2+random(96);
					int k=ne+2;
					if ((ex=(unsigned char*) realloc(ex,k))==NULL)
					{
						stop();
					}
					if ((ey=(unsigned char*) realloc(ey,k))==NULL)
					{
						stop();
					}
					ex[ne]=x;
					ey[ne]=y;
					ex[ne+1]=0;
					ey[ne+1]=0;
					ne++;
					drawEnemy(x,y);
	    	}
			}
			SetIntVec(AUTO_INT_1,interrupt1);
    	SetIntVec(AUTO_INT_5,interrupt5);
			ClrScr();
			FontSetSys(F_8x10);
			DrawStr(10,10,"GAME OVER",A_NORMAL);
			FontSetSys(F_6x8);
			char* buff=NULL;
			if ((buff=calloc(20,sizeof(char)))==NULL)
			{
				stop();
			}
			sprintf(buff,"Score: %d",score);
			DrawStr(10,24,buff,A_NORMAL);
			free(buff);
			hs[10]=score;
			qsort(hs,11,sizeof(short),cmp);
			while (ngetchx()!=KEY_ENTER);
			{
				
			}
		}
	if (choice==1)
	{
		ClrScr();
		FontSetSys(F_8x10);
		DrawStr(32,5,"Instructions",A_NORMAL);
		FontSetSys(F_6x8);
		DrawStr(2,15,"Use the left and right",A_NORMAL);
		DrawStr(2,23,"arrow keys to move the",A_NORMAL);
		DrawStr(2,31,"ship. Use 2nd to shoot.",A_NORMAL);
		ngetchx();
	}
	if (choice==2)
	{
		ClrScr();
		FontSetSys(F_8x10);
		DrawStr(60,5,"About",A_NORMAL);
		FontSetSys(F_6x8);
		DrawStr(38,15,"Programming by:",A_NORMAL);
		DrawStr(44,23,"blue_bear_94",A_NORMAL);
		DrawStr(29,31,"Brought to you by",A_NORMAL);
		DrawStr(26,39,"Ardtha Productions",A_NORMAL);
		DrawStr(38,47,"Made with TIGCC",A_NORMAL);
		ngetchx();
	}
	if (choice==3)
	{
		clrscr();
		printf("HIGHSCORES\n");
		int i=0;
		for(i=0;i<5;i++)
		{
			printf("%2hd %4hd %2hd %4hd\n",i+1,hs[i],i+6,hs[i+5]);
		}
		ngetchx();
	}
	}
	//We hate memory leaks, so we do this.
	free(ex);
	free(ey);
	
}
